<?php
/**
 * @version $Id: 1.0
 * @package Sigsiu Online Business Index 2
 * @authorName Sigrid & Radek Suski, Sigsiu.NET
 * @authorEmail info@sigsiu.net
 * @authorUrl http://www.sigsiu.net
 * @copyright Copyright (C) 2007 Sigsiu.NET (http://www.sigsiu.net). All rights reserved.
 * @license see http://www.gnu.org/copyleft/gpl.html GNU/GPL.
 * SOBI2 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 * sef_ext.php 20-Jan-2007 Radek Suski
 */

/**
 * Modified for SEF Advance by Emir Sakic, http://www.sakic.net
 * v1.5 (2010-04-11)
 *
 * Limitations:
 * - no category should have the same name as any of entries
 * - tested with SOBI2 RC 2.9.1
 */

(defined( '_VALID_MOS' ) || defined( '_JEXEC' )) or die( 'Restricted access' );
!defined('_OPENSEF') or die('This extension is for SEF Advance only. http://www.sakic.net');

define('_SOBI2_ADD_ENTRY',"add new entry");
define('_SOBI2_SEARCH',"search");
define('_SOBI2_RENEW',"renew");
define('_SOBI2_REPORT',"report");
define('_SOBI2_RSS',"rss");
define('_SOBI2_USERS',"users");

if (empty($database)) {
	global $database;
	$database = JFactory::getDBO();
}

class sef_sobi2 {

	var $catParents = array();
	var $sobiMenuId = null;
	var $limit = null;
	var $SobiAlias = null;

    function getLimit() {
    	global $database;
    	$query = "SELECT `configValue` FROM `#__sobi2_config` WHERE (`configKey` = 'itemsInLine' OR `configKey` = 'lineOnSite')";
    	$database->setQuery( $query );
    	$l = $database->loadObjectList();
    	$this->limit = (int)$l[0]->configValue * (int)$l[1]->configValue;
    }
    function getCatName($cid) {
    	global $database;
		$this->getParentCats($cid);
		$this->catParents = array_reverse($this->catParents);
		$catName = null;
		foreach($this->catParents as $cid) {
			$query = "SELECT `name` FROM `#__sobi2_categories` WHERE (`catid`= {$cid} AND `published` = 1)";
			$database->setQuery( $query );
			$cat = html_entity_decode($database->loadResult());
			$cat = sefencode($cat);
			$catName .= "{$cat}/";
		}
		return $catName;
    }
    function getItemName($id){
    	global $database;
    	$query = "SELECT `title` FROM `#__sobi2_item` WHERE (`itemid`={$id} AND `published` = 1)";
		$database->setQuery( $query );
		$itemName = html_entity_decode($database->loadResult());
		return sefencode($itemName);
    }
	function getParentCats ($catid) {
		global $database;
		$query = "SELECT `parentid` from `#__sobi2_cats_relations` WHERE `catid`= {$catid}";
		$database->setQuery( $query );
		if($catid != 1)
    		array_push($this->catParents, $catid);
    	if(sizeof($database->loadResult()) != 0)
			$this->getParentCats($database->loadResult());
	}
    function getCatId($string, $pid) {
		global $database;
		$string = htmlentities($string);
		$string = sefdecode($string);
   		$query = "SELECT cats.catid FROM `#__sobi2_categories` AS cats " .
   				 "LEFT JOIN `#__sobi2_cats_relations` AS rel ON cats.catid = rel.catid " .
   				 "WHERE cats.name LIKE '{$string}' AND rel.parentid = '{$pid}'";
		$database->setQuery( $query );
		return $database->loadResult();
    }
    function getEntryId($string, $cid = 0) {
		global $database;
		$string = htmlentities($string);
		$string = sefdecode($string);
		$items = array();
		if(!$cid)
			$query = "SELECT `itemid` FROM `#__sobi2_item` WHERE (`title` LIKE '{$string}' AND `published` = 1)";
		else
			$query = "SELECT items.itemid FROM `#__sobi2_item` AS items " .
					 "LEFT JOIN `#__sobi2_cat_items_relations` AS rel ON items.itemid = rel.itemid " .
					 "WHERE (items.title LIKE '{$string}' AND `published` = 1 AND rel.catid = '$cid' )";
		$database->setQuery( $query );
		return $database->loadObjectList();
    }

    function create($string) {
    	global $database;

    	$sefstring = null;
    	$details = false;
		
        /* alpha index */
        if(eregi("&amp;letter=",$string)) {
            $temp = split("&amp;letter=", $string);
            $temp = split("&", $temp[1]);
            $letter = $temp[0];
            $sefstring .= $letter."/";
        }

        /* get the task */
        if(eregi("&amp;sobi2Task=",$string)) {			
            $temp = split("&amp;sobi2Task=", $string);
            $temp = split("&", $temp[1]);
            /* if adding new - return */
            if($temp[0] == 'addNew') {
            	$task = sefencode(_SOBI2_ADD_ENTRY)."/";
				return $task;
            }
            /* if search - return */
            else if($temp[0] == 'search') {
            	$task = sefencode(_SOBI2_SEARCH)."/";
				return $task;
            }
            /* if details - set the flag */
            else if($temp[0] == 'sobi2Details') {
            	$details = true;
            }
            else if($temp[0] == 'renew') {
            	$sefstring = sefencode(_SOBI2_RENEW)."/";
            	$details = true;
            }
            else if($temp[0] == 'report_listing') {
            	$sefstring = sefencode(_SOBI2_REPORT)."/";
            	$string = str_replace('sid=', 'sobi2Id=', $string);
            	$details = true;
            }
			else if ($temp[0] == 'rss') {
            	$sefstring = sefencode(_SOBI2_RSS)."/";
				$string = str_replace('catid=&amp;', '', $string);
			}
			else if ($temp[0] == 'usersListing') {
            	$sefstring = sefencode(_SOBI2_USERS)."/";
			}
        }
        /* get catid */
        if(eregi("&amp;catid=",$string)) {
            $temp = split("&amp;catid=", $string);
            $temp = split("&", $temp[1]);
            if(!empty($temp[0])) {
	            $cat = $this->getCatName($temp[0]);
	            $sefstring .= "{$cat}";
            }
        }
        /* and now get sobiid */
        if(eregi("&amp;sobi2Id=",$string) && $details) {
            $temp = split("&amp;sobi2Id=", $string);
            $temp = split("&", $temp[1]);
            $itemName = $this->getItemName($temp[0]);
            $sefstring .= $itemName."/";
        }
        /* if next listing page */
        else if(!$details) {
        	if(eregi("&amp;limit=",$string)) {
        		$temp = split("&amp;limit=", $string);
        		$temp = split("&", $temp[1]);
        		$this->limit = $temp[0];
        	}
        	else if(!$this->limit)
        		$this->getLimit();

        	if(eregi("&amp;limitstart=",$string)) {
        		$temp = split("&amp;limitstart=", $string);
        		$temp = split("&", $temp[1]);
        		$limitstart = $temp[0];
        	}
        	else
        		$limitstart = 0;
     		$page = $limitstart / $this->limit;
     		$page = (int)$page + 1;

     		if (!is_numeric( $page )) {
     			mosRedirect( "/index.php", "Error: creating SEF URL");
     			return null;
     		}
			if ($page > 1) {
          		$sefstring .= "$page/";
			}
        }
        return $sefstring;
    }

    function revert($url_array, $pos) {
    	global $database, $uri;

    	$catsIds = array();
    	$queryString = null;

		/* if nothing after component name */
    	if (empty($url_array[$pos+2])) {
    		return $queryString;
    	}

		if (sefdecode($url_array[$pos+2]) == _SOBI2_RSS) {
			/* RSS */
			$queryString = "&sobi2Task=rss&no_html=1";
			$_REQUEST['sobi2Task'] = $_GET['sobi2Task'] = $_POST['sobi2Task'] = 'rss';
			$_REQUEST['no_html'] = $_GET['no_html'] = $_POST['no_html'] = 1;
			$catid = '';
			if(isset($url_array[$pos+3]) && $url_array[$pos+3] != '') {
				$catName = $url_array[$pos+3];
				$catid = $this->getCatId($catName, 1);
			}
			$_REQUEST['catid'] = $_GET['catid'] = $_POST['catid'] = $catid;
			$queryString .= "&catid=$catid";
			return $queryString;
		}
		else if(strlen($url_array[$pos+2]) == 1 && !is_numeric($url_array[$pos+2])) {
			/* alpha index */
			$queryString = '&letter='.$url_array[$pos+2];
			$_REQUEST['letter'] = $_GET['letter'] = $_POST['letter'] = $url_array[$pos+2];
			if (isset($url_array[$pos+3]) && is_numeric($url_array[$pos+3])) {
				$pageNumber = $url_array[$pos+3];
				if(!$this->limit) {
					$this->getLimit();
				}
				$limitStart = ($this->limit * ($pageNumber - 1));
				$_REQUEST['limit'] = $_GET['limit'] = $_POST['limit'] = $this->limit;
				$_REQUEST['limitstart'] = $_GET['limitstart'] = $_POST['limitstart'] = $limitStart;
				$queryString .= "&limit={$this->limit}&limitstart={$limitStart}";
			}
			return $queryString;
		}
		else if(empty($url_array[$pos+3])) {
			$value = sefdecode($url_array[$pos+2]);
			/* add new entry function */
			if($value == _SOBI2_ADD_ENTRY) {
				$queryString = "&sobi2Task=addNew";
				$_REQUEST['sobi2Task'] = $_GET['sobi2Task'] = $_POST['sobi2Task'] = 'addNew';
				return $queryString;
			}
			/* search function */
			else if($value == _SOBI2_SEARCH) {
				$queryString = "&sobi2Task=search";
				$_REQUEST['sobi2Task'] = $_GET['sobi2Task'] = $_POST['sobi2Task'] = 'search';
				return $queryString;
			}
			/* users listing */
			else if (sefdecode($url_array[$pos+2]) == _SOBI2_USERS) {
				/* report listing function */
				$queryString = "&sobi2Task=usersListing";
				$_REQUEST['sobi2Task'] = $_GET['sobi2Task'] = $_POST['sobi2Task'] = 'usersListing';
				return $queryString;
			}
		} else if (sefdecode($url_array[$pos+2]) == _SOBI2_RENEW) {
			/* renew function */
			$queryString = "&sobi2Task=renew";
			$_REQUEST['sobi2Task'] = $_GET['sobi2Task'] = $_POST['sobi2Task'] = 'renew';
			$title = $url_array[$pos+3];
			$items = $this->getEntryId($title);
			$sobi2Id = $items[0]->itemid;
			$_REQUEST['sobi2Id'] = $_GET['sobi2Id'] = $_POST['sobi2Id'] = $sobi2Id;
			$queryString .= "&sobi2Id=$sobi2Id";
			return $queryString;
		} else if (sefdecode($url_array[$pos+2]) == _SOBI2_REPORT) {
			/* report listing function */
			$queryString = "&sobi2Task=report_listing";
			$_REQUEST['sobi2Task'] = $_GET['sobi2Task'] = $_POST['sobi2Task'] = 'report_listing';
			$title = $url_array[$pos+3];
			$items = $this->getEntryId($title);
			$sid = $items[0]->itemid;
			$_REQUEST['sid'] = $_GET['sid'] = $_POST['sid'] = $sid;
			$queryString .= "&sid=$sid";
			return $queryString;
		}

		/* how deep is the array */
		$deep = count($url_array)-2;
		$pages = false;
		/* check the last element */
		$title_str = $url_array[$deep];
		if (is_numeric($title_str)) {
			/* is the next listing page and not an entry */
			$pageNumber = $title_str;
			if(!$this->limit) {
				$this->getLimit();
			}
			$limitStart = ($this->limit * ($pageNumber - 1));
			$_REQUEST['limit'] = $_GET['limit'] = $_POST['limit'] = $this->limit;
			$_REQUEST['limitstart'] = $_GET['limitstart'] = $_POST['limitstart'] = $limitStart;
			$limits = "&limit={$this->limit}&limitstart={$limitStart}";
			$pages = true;
			/* if this is the next page in the listing on frontpage */
			if($url_array[$deep-2] == 'component') {
				return $limits;
			}
		}
		$entries = $this->getEntryId($title_str);
		if(count($entries)) {
			$title = sefdecode($url_array[$deep]);
			$items = $this->getEntryId($url_array[$deep]);
			if(!(count($items))) {
					//mosRedirect( "/index.php", "Error: reversing SEF URL - missing entry id");
					return null;
			}
			/* if no category f.e. in search results or frontpage */
			if((count($items) == 1) && $url_array[$deep-2] == 'component') {
				$sobiId = $items[0]->itemid;
				$_REQUEST['sobi2Task'] = $_GET['sobi2Task'] = $_POST['sobi2Task'] = 'sobi2Details';
				$_REQUEST['sobi2Id'] = $_GET['sobi2Id'] = $_POST['sobi2Id'] = $sobiId;
				$queryString = "&sobi2Task=sobi2Details&sobi2Id={$sobiId}";
				return $queryString;
			}
		}
		$parentCat = 1;
		/* getting categories id from left to right */
		for($i = $pos+2; $i <= $deep ; $i++) {
			if(isset($url_array[$i]) && $url_array[$i] != '') {
				$catName = $url_array[$i];
				$cid = $this->getCatId($catName, $parentCat);
				if ($cid) {
					$catsIds[] = $cid;
				}
				$parentCat = $cid;
			}
		}
		/* if this is category view */
		if(empty($items)) {
			$queryString = "";
			if (!empty($catsIds)) {
				$catId = $catsIds[count($catsIds) - 1];
				$_REQUEST['catid'] = $_GET['catid'] = $_POST['catid'] = $catId;
				$queryString .= "&catid={$catId}";
			}
			if(isset($limits) && $limits)
				$queryString .= $limits;
			return $queryString;
		}
		$queryCat = "";
		/* if details view called from some category view and we have already one entry id */
		if(isset($items) && count($items) == 1) {
			$sobiId = $items[0]->itemid;
			if (count($catsIds)) {
				$catId = $catsIds[count($catsIds) - 1];
				$queryCat = "&catid={$catId}";
			}
		/* last chance to get the right entry id */
		} else if(isset($title)) {
			$items = $this->getEntryId($title, $catsIds[count($catsIds) - 1]);
			$sobiId = $items[0]->itemid;
		}
		/* Huston .....  we have a problem */
		if(!$sobiId) {
 			mosRedirect( $uri[0]."index.php", "Error: reversing SEF URL - cannot find right sobi2id");
 			return null;
		}
		$_REQUEST['sobi2Task'] = $_GET['sobi2Task'] = $_POST['sobi2Task'] = 'sobi2Details';
		if (empty($catId)) {
			$catId = 0;
		}
		$_REQUEST['catid'] = $_GET['catid'] = $_POST['catid'] = $catId;
		$_REQUEST['sobi2Id'] = $_GET['sobi2Id'] = $_POST['sobi2Id'] = $sobiId;
		$queryString = "&sobi2Task=sobi2Details{$queryCat}&sobi2Id={$sobiId}";
		return $queryString;
    }
}
?>